#!/usr/bin/perl -w

# Take the header files documenting errnos and signals and turn them
# into a message catalogue file (gettext .po format) on stdout.

use OSDlib;

$errnohdr="/usr/include/asm/errno.h";
$signalhdr="/usr/include/signal.h";

open G,"gcc -undef -E -dM $errnohdr|" or die "Couldn't run gcc -E over errno header file $errnohdr: $!\n";

while(<G>) {
    if (/^#define\s(E\w+)\s(\d+)/) {
	$!=$2;
	$Enobydesc{$!}=$1;
    }
}
	
close G or die;

foreach (keys %Enobydesc) {
    print "msgid \"$_\"\nmsgstr \"$Enobydesc{$_}\"\n";
}

open G,"gcc -undef -E -dM $signalhdr|" or die "Couldn't run gcc -E over signal.h header file $signalhdr: $!\n";

while(<G>) {
    if (/^#define\s(SIG[A-Z]+)\s(\d+)/) {
	$sigdesc=OSDlib::strsignal($2);
	chomp $sigdesc;
	$Snobydesc{$sigdesc}=$1;
    }
}
	
close G or die;

foreach (keys %Snobydesc) {
    print "msgid \"$_\"\nmsgstr \"$Snobydesc{$_}\"\n";
}
